var sid;
var sadeUser;
var sadePw;
var page;
var t;
var i;
var test;

$(document).ready(function(){

// general setup (ajax, variables, …)
    $.ajaxSetup({ cache:false });

    $('#sid').change(function() {
        sid=$(this).val();
    });

    $('#user').change(function() {
        sadeUser=$(this).val();
    });

    $('#password').change(function() {
        sadePw=$(this).val();
    });

    forked();

    log("publish engine: ready");

    $('#droptarget').bind('drop', function(evt) {
        log("got a drop");
        var data = evt.originalEvent.dataTransfer.getData('text/html');
        var uri = $(data).attr('uri');
        var title = $(data).text();
        var type = $(data).attr('type');
        log(uri + "|" + title + '|' +type);
        addTGObject(uri, title, type);
        $(this).removeClass('dragover');
	    evt.preventDefault();
        evt.stopPropagation();
    }).bind('dragenter', function(evt) {
        $(this).addClass('dragover');
	    evt.preventDefault();
        evt.stopPropagation();
    }).bind('dragover', function(evt) {
	    evt.preventDefault();
        evt.stopPropagation();
    }).bind('dragleave', function(evt) {
        $(this).removeClass('dragover');
	    evt.preventDefault();
        evt.stopPropagation();
});

    $('#ajaxLoadIndicator')
    .hide()  // hide it initially
    .ajaxStart(function() {
        $(this).show();
    })
    .ajaxStop(function() {
        $(this).hide();
    });
});

function setSid(val) {
    $('#authform').hide();
	sid=val;
	log('got a SessionId '+sid);
}

function setAuth(user, pw) {
    $('#authform').hide();
    sadeUser = user;
    sadePw = pw;
    $("input[name=forkUser]").val(sadeUser);
    $("input[name=forkPassword]").val(sadePw);
    log('got credentials to the database for user '+user);
}

function publish() {
	log('starting...');

	$('#logbox').show();
	$("#droptarget").find("tr[id^='uri']").each(function() {
		var uri = $(this).children()[2].textContent;
		var uriId = $(this).attr("id");
        if(sadeUser === undefined) {
            sadeUser = $('#user').val();
            sadePw = $('#password').val();
            sid = $('#sid').val();
        }

		var sidreq = sid ? "&sid="+sid : "";
        var target="data";

		$.ajax({
		    type: 'POST',
			url: 'modules/textgrid/publish.xql',
			data: {'uri': uri,  'target': target, 'user': sadeUser, 'password': sadePw, 'sid': sid},
			cache: false,
			success: function(xml) {
                test = $(xml).find('message');
			    if($(xml).find('ok').text()) {
			        $(xml).find('ok').each( function(){
			                log('success: ' + $(this).text() );
                        });
    				$('#'+uriId).addClass("success");
    				// lets check for a validation report:
    				vali = $(xml).find('status').text();
    				if (vali.length > 0){
			        log('validation status: ' + vali);}
              for (i = 0; i < test.length; i++) {
              $('#log').append( test[i] );
              $('#log').append( "<br/>" );
              }
			    } else {
			        errnote = $(xml).find('error').text();
			        log('error: ' + errnote);
    				$('#'+uriId).addClass("danger");
			    }
			},
			error: function(xml){
			    message = xml.responseXML.childNodes["0"].childNodes[1].textContent
			    log('<span style="color:red;">ERROR: ' + message + '</span>');
				$('#'+uriId).addClass("danger");
			}
		});
	});
}

function addTGObject(uri, title, contentType) {
    if( uri.split(".").length === 3 ) {
        // this is a workaround a bug in the Navigator. it drops an incorrect URI
        uri = uri.split(".")[0] + "." + uri.split(".")[1]
    }
	var shortUri = uri;
	if(uri.beginsWith('textgrid:')) {
		var shortUri = uri.substring(9);
	}

	var uriId = 'uri'+shortUri.replace("\.", "_");

	/* if element id already there, do not add again, blink instead */
	if($('#'+uriId).length > 0) {
		$('#'+uriId).addClass('blink');
		setTimeout(function() { $('#'+uriId).removeClass('blink'); }, 1000);
		return;
	}
	else {
    	$('#droptarget table tbody td[colspan=4]').remove();
    	$('#droptarget table tbody').append(
            '<tr id="'+ uriId +'"><td>'+ title.substr(0, title.indexOf(' (')) + '</td><td>'+ contentType +'</td><td>'+ uri +'</td><td><i class="fas fa-trash" onclick="$(this).parent().parent().remove();"></i></td></tr>');
        $('table').css("color", "black");
	}
}

function getMimeClass(contentType) {
	if(contentType.beginsWith('text/tg.collection+tg.aggregation')) {
		return 'mime_collection';
	} else if (contentType.beginsWith('text/tg.edition+tg.aggregation')) {
		return 'mime_edition';
	} else if(contentType.indexOf('tg.aggregation') != -1) {
		return 'mime_aggregation';
	} else if (contentType.beginsWith('text/tg.work+xml')) {
		return 'mime_work';
	} else if (contentType.beginsWith('text/xml')) {
		return 'mime_xml';
	} else if (contentType.beginsWith('text/linkeditorlinkedfile')) {
		return 'mime_tble';
	} else if (contentType.beginsWith('image')) {
		return 'mime_image';
	} else {
		return 'mime_unknown';
	}
}

function reset() {
	$('#droptarget table tbody').empty();
	$('#droptarget table tbody').append('<tr><td colspan="4" style="text-align: center;font-size:150%;color:grey;">Drop your Objects here or use the content menu entry "Publish to SADE" on a TextGrid object from within the Navigator.</td></tr>');
	$('table').css("color", "grey");
	$('#viewData').empty();
}

String.prototype.beginsWith = function (string) {
    return(this.indexOf(string) === 0);
}

function format(num){
    if (num < 10) { return "0" + num; }
    else { return num }
}

function log(string) {
    var date = new Date();
    var hour = format(date.getHours());
    var min = format(date.getMinutes());
    var sec = format(date.getSeconds());
    var timeStamp = hour + ":" + min + ":" + sec;
    $('#log ul').append('<li><span>'+ timeStamp +'</span>' + string + '</li>');
    $( "#log" ).scrollTop(1000000);
}
function view(string) {
    $('#view').prepend(string + '<hr/>');
}
function links(string) {
    $('#view').prepend(string + '<hr/>');
}

function forked() {
  var url = new URL( window.location.href );
  var newpw = url.searchParams.get("newpw");
  if( newpw ) {
    $("#newpw").text(newpw);
    $("url").text( window.location.origin + window.location.pathname );
    $("#fork-successull").show();
  }
}
